
;================================================================================================
;================================================================================================
;                 " "
;
;================================================================================================    :  , ., e-mail - bash-07@yandex.ru
;================================================================================================





			LIST         P=16F628A

			#INCLUDE     p16f628a.inc

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================


   __CONFIG (_BOREN_OFF&_CP_OFF&_DATA_CP_OFF&_PWRTE_ON&_WDT_OFF&_LVP_OFF&_MCLRE_OFF&_XT_OSC)     



;====================================================================================
;    ()
; =================================================================================== 

LED_OUT_0                    equ        70h   
LED_OUT_1                    equ        71h   
LED_OUT_2                    equ        72h   
LED_OUT_3                    equ        73h ; 4     

column                       equ        74h ; 0, 1, 2, 3  - 1- 
status_temp                  equ        75h 
w_temp                       equ        76h
length_                      equ        77h ;    ( 1 )

pause_						 equ        78h ;  - *4  - max 1c
pause_H                      equ        79h ; pause  max - 256c (.  )
flags_                       equ        7ah
       ; : 0- .  -  . .   . 16 . 
       ; 1-    .  U.( -  . ),
       ; 2-   pause_H (1 ), 3-   ,
       ; 4-   , ; 5-   ,
       ; 6- , 7-   2 ., 

tmr1_count					 equ        7bh ; .  - . 4  TMR1

Time_H                       equ        7ch
Time_L                       equ        7dh ;    .  .

L_sum_L                      equ        7eh
L_sum_H                      equ        7fh ; .  100 

 
OUT_0                        equ        20h   
OUT_1                        equ        21h   
OUT_2                        equ        22h   
OUT_3                        equ        23h ;  4 .  

count_                       equ        24h

dist_0                       equ        25h ;    (0.1 )
dist_1                       equ        26h ; 4-. . .  

dist_all_0                   equ        27h ;  
dist_all_1                   equ        28h ; 4-. . .  

dist_10                      equ        29h


out_bcd_2                    equ        2ah ;. .
out_bcd_1                    equ        2bh ;.  .
out_bcd_0                    equ        2ch ;.  

bright_comma                 equ        2dh ;.  -, -

var_temp                     equ        2eh ;   
regime_                      equ        2fh ; 
 
Speed_L                      equ        30h
Speed_H                      equ        31h
Speed_Hst                    equ        32h ; 3- .  -   

Neg_Time_L                   equ        33h
Neg_Time_H                   equ        34h
Neg_Time_Hst                 equ        35h ; -  Time_

Rest_L                       equ        36h        
Rest_H                       equ        37h        
Rest_Hst                     equ        38h ;   . (. ) 

var_pause                    equ        39h ; -   
pause_Hst                    equ        3ah ; 3-    
dst_out                      equ        3bh
reg_temp                     equ        3ch
flash_flags                  equ        3dh ;  .   0 -  
                                            ;     
Time_Hst                     equ        3eh

speed_max_L                  equ        3fh ; .   
speed_max_H                  equ        40h ;

dist_T_L                     equ        41h ;
dist_T_H                     equ        42h ;    
;----------------------------------------------------------------------------
   

;----------------------------------------------------------------------------------
;                 EEPROM
;   00h -  length_ (   )
;   01h - 02h -  
;   03h - 04h -  
;   05h -    (dist_10)
;   06h -   (0-15)
;----------------------------------------------------------------------------------
			org  h'2100'
			de        .200,0h,0h,0h,0h,0h,3h ; length_ =.200, . - .

			org  h'2110'
			de        "Author:  Bashir Balayev. Nalchik. bash-07@yandex.ru"


     
            org 0  
	        goto      begin



;==================================================================================
;==================================================================================
;      
;==================================================================================
;==================================================================================			          

			org 4

			movwf       w_temp
            swapf       STATUS,w
            movwf       status_temp  ;coxpa W  STATUS

			clrw        
            movwf       STATUS ; 0,  0
		
          
        	btfsc       INTCON,T0IF
            goto        tmr0_int 

			btfsc       PIR1,TMR2IF
            goto        tmr2_int
 
 			btfsc       PIR1,TMR1IF
            goto        tmr1_int

			btfsc       INTCON,INTF
			goto        RB0_int

;============================   TMR0 ===============================
tmr0_int            
			incf        pause_,f   ;  "pause_"  4 
			btfss       STATUS,Z
			goto        tmr0_1
			bsf         flags_,2 ;   pause_H
			incf        pause_H,f  ;  1.04856 
			btfsc       STATUS,Z
			incf        pause_Hst,f  ;
tmr0_1  
			movlw       b'00010000'
			btfsc       column,0  ;   0- 
			movwf       column    ;   3-  
			rrf         column,f  ; . 
  
	   
			movlw       0ffh                                         
 			movwf       PORTB     ;

			movf        column,w
			iorlw       b'11110000'   ;  . . ( )
			btfss       pause_,7
			andwf       flash_flags,w  ;  

			xorlw       b'00001111'                                  
			movwf       PORTA

		    btfsc       column,0                                     
			comf        LED_OUT_0,w
            btfsc       column,1
			comf        LED_OUT_1,w 
            btfsc       column,2
			comf        LED_OUT_2,w			
            btfsc       column,3
			comf        LED_OUT_3,w		                         
			movwf       PORTB      ;    LED_OUT . 
 
            andlw       b'00000001'

            btfsc       STATUS,Z                                                  
            bcf         PORTA,4     ;  0-  = 1,  

            bcf         INTCON,T0IF  ;   TMR0
			clrf        TMR2         ;  TMR2
			nop
            bcf         PIR1,TMR2IF  ;   TMR2            
			bsf         STATUS,RP0   ; bank 1
            bsf         PIE1,TMR2IE   ; . . TMR2
			goto        exit_ 

;========================     RB0=======================
RB0_int   			
			bcf         T1CON,TMR1ON ;  TMR1

			btfss       PIR1,TMR1IF  ;   .  TMR1
			goto        swa_
			bcf         PIR1,TMR1IF  ; 
			movlw       0ffh          ;  TMR1 'FFFF'
			movwf       TMR1H
			movwf       TMR1L

swa_        swapf       tmr1_count,f ;       - - - - - - - 
			swapf       TMR1H,w    ;        
			movwf       Time_L      
			andlw       b'00001111'  ;     
			iorwf       tmr1_count,w
			movwf       Time_H       ;   Time_H+Time_L -  
			movlw       b'11110000'
			andwf       Time_L,f     ;      tmr1_count, 
            andwf       TMR1L,f
			swapf       TMR1L,w      ;   TMR1H    TMR1L ( 
            iorwf       Time_L,f     ;    )
            clrf        TMR1H        
            clrf        TMR1L
			bsf         T1CON,TMR1ON ;  TMR1
			clrf        tmr1_count

;---------------     ---------------------------------
			movf       length_,w
			addwf      L_sum_L,f  ;   2-.  .  ()
			btfss      STATUS,C
			goto       no_        ;   
			incfsz     L_sum_H,f  ;, . . .    
			goto       no_        ; 100 

;-----------------------------------------------------------------------------------
;           . : 
;   . 2-  dist_  dist_all_   "1 " - dist_10 
;-----------------------------------------------------------------------------------

	 			;------------  "1 "-----------------------------    
			incf      dist_10,f
			movf      dist_10,w
			sublw     .9     
			btfsc     STATUS,C 
			goto      end_incr_all
			clrf      dist_10

					;---------------    (100m x 10)----------

			incf      dist_all_0,f
			btfsc     STATUS,Z
			incf      dist_all_1,f

end_incr_all        ; ---------------   --------------
			bsf       flags_,3 ;    
			incf      dist_0,f
			btfsc     STATUS,Z
			incf      dist_1,f

			incf      dist_T_L,f
			btfsc     STATUS,Z
			incf      dist_T_H,f  ;    
			

end_incr	;---------------------   -----------------

			movlw      0d8h
			movwf      L_sum_H			
			movlw      0efh
			addwf      L_sum_L,f
			btfsc      STATUS,C
			incf       L_sum_H,f    ;    "100" . . - D8EFh

no_   ;------------------------   1- ------------------------



		    bcf         INTCON,INTF    ;   .  
			bsf         flags_,4  ;   
			btfsc       flags_,6  ;     
			bsf         flags_,5  ;  . 

			bcf         flags_,6  ;   
			bcf         flags_,7  ;    2 .	

			goto        exit_				

;=============================  TMR1==================================			
tmr1_int    bcf         PIR1,TMR1IF  ;   TMR1
			movlw       .1
			addwf 		tmr1_count,f   ;  '+'   			
			btfsc       STATUS,DC      ; :
			bsf         flags_,6  ;  
			btfsc       STATUS,Z
			bsf         flags_,7  ;    2 .			

			goto        exit_

;=============================  TMR2==================================				
tmr2_int 
            bcf         PIR1,TMR2IF  ;   
 
            movlw       b'00001111'                                     
			iorwf       PORTA,f ;                     

			bsf         STATUS,RP0   ; BANK 1
            bcf         PIE1,TMR2IE   ;  . TMR2

;=========================     ==============================
exit_       swapf       status_temp,w
            movwf       STATUS
            swapf       w_temp,f  ;  W  STATUS
            swapf       w_temp,w
 			retfie

;-----------------------------------------------------------------------------------
;===================================================================================





;====================================================================================
;       7-.   w = 26 max
; ===================================================================================

Table_s     addwf       PCL,f        ;    PC 
                                    ;     W.
            retlw       b'01111110' ; = 0        
            retlw       b'00001100' ; = 1 = 'I'           0-  - 
            retlw       b'10110110' ; = 2                  - 
            retlw       b'10011110' ; = 3                  :
            retlw       b'11001100' ; = 4                 '1234567' 
            retlw       b'11011010' ; = 5 = 'S'            
            retlw       b'11111010' ; = 6                 'abcdefg'
            retlw       b'00001110' ; = 7                                     
            retlw       b'11111110' ; = 8                                     
            retlw       b'11011110' ; = 9                    
            retlw       b'11101110' ;   A - 10
            retlw       b'11111000' ;   b - 11
            retlw       b'01110010' ;   C - 12
            retlw       b'10111100' ;   d - 13
            retlw       b'11110010' ;   E - 14   
            retlw       b'11100010' ;   F - 15
            retlw       b'00000000' ;   - 16
            retlw       b'11100110' ;   P - 17
            retlw       b'11110000' ;   t - 18                           
            retlw       b'01110000' ;   L - 19
            retlw       b'10100000' ;   r - 20
            retlw       b'00010000' ;  '_' - 21
            retlw       b'00111000' ;  'u' - 22
            retlw       b'11011100' ;   Y - 23
			retlw       b'01111100' ;   U - 24
		    retlw       b'11101100' ;   H - 25
		    retlw       b'10000000' ;  '-'- 26
		    retlw       b'00000010' ;  '. '- 27

;------------------------------------------------------------------------------------

;====================================================================================
;            ,    'StOP'
;        -  pause_H
;====================================================================================

stop_ind__	rlf       pause_H,w
			andlw     b'00000110'			
			addwf     PCL,f    ;   1, 3, 5, 7   .  0  1  pause_H
			call      out_stop__
			retlw     0
			call      dist_out__
			retlw     1
			call      dist_all_out__
			retlw     2
			call      time_calc__
			retlw     3     
;------------------------------------------------------------------------------------




;====================================================================================
;           
;     W -,    - ,   -   
;   
;====================================================================================
Upp__		bcf       INTCON,GIE
			bcf       PORTA,1      ; a1=0
			bsf       PORTA,4

			movlw     0ffh
			movwf     PORTB    ;                      
	
			movlw     b'00000010'  ;   . V. 
			movwf     CMCON
			bsf       STATUS,RP0   ;  1
			movlw     b'11100001'
			movwf     TRISA        ; RA0 - . 
			movlw     b'10100100'   ; U.=4/24*Upp
			movwf     VRCON        ; . .    ., . . 
			bcf       STATUS,RP0   ; 0
			movlw     .25
			call      delay_Wx6__  ; 0.15 msec

test_		movlw     2
			call      delay_Wx6__   ;  15 .
			bcf       STATUS,RP0   ;  0			
			btfsc     CMCON,C1OUT  ;   ,  Vp>Ura1 
			goto      end_test
			movlw     b'10101111'
			bsf       STATUS,RP0   ;  1  
			xorwf     VRCON,w
			btfsc     STATUS,Z     ;   Vp=16/24*Upp
			goto      end_test
			incf      VRCON,f      ;  Vp
			goto      test_

end_test	bcf       STATUS,RP0   ;  0			
			movlw     b'00000111'  ; comp- off
			movwf     CMCON
			movlw     b'11100000'
			bsf       STATUS,RP0   ;  1  
			movwf     TRISA      
			bsf       INTCON,GIE  ; .
			movf      VRCON,w
			clrf      VRCON      ;  V
			bcf       STATUS,RP0   ;  0
			andlw     b'00001111'
			addlw     -4
			addwf     PCL,f   ;   w=Upp (*0.1 B)
			retlw     29h
			retlw     31h
			retlw     32h
			retlw     33h
			retlw     34h
			retlw     36h
			retlw     37h
			retlw     38h
			retlw     39h
			retlw     41h
			retlw     42h
			retlw     43h	 

;-------------------------------------------------------------------------




;====================================================================================
;                                 
;====================================================================================
;                  ()
;====================================================================================
begin       bcf       STATUS,RP1
			bsf       STATUS,RP0  ; bank 1
			movlw     b'00000001'
			movwf     TRISB
			movlw     b'11100000'
			movwf     TRISA
            movlw     07h
			movwf     CMCON  ; .
          	movlw     b'10000011'
            movwf     OPTION_REG  ; TMR0  . . .- 16
            movlw     b'00000011'
			movwf     PIE1     ;   TMR2  TMR1 
 		
			bcf       STATUS,RP0 ; bank0
			movlw     b'00110001'
			movwf     T1CON      ; TMR1 . . - 8, . OSC

            movlw     b'00000111'
			movwf     T2CON     ;  TMR2, . = 16. .  - 0.
            clrf      Time_H
			clrf      Time_L
		    clrf      TMR0		
			clrf      TMR2
		    clrf      TMR1L		
			clrf      TMR1H
			clrf      pause_
			clrf      pause_H
			clrf      pause_Hst
			clrf      flags_
			clrf      speed_max_L   
			clrf      speed_max_H  
			clrf      dist_T_L     
			clrf      dist_T_H  			

            movlw     b'00000001'
			movwf     dst_out ; -  . .-.- 
            movwf     column     ;  "0"
			movwf     regime_    ;  ""
			movlw     0ffh
			movwf     flash_flags ;   


;-------------    EEPROM ------------------------------------------

			bsf        STATUS,RP0  ;BANK 1
			clrf       EEADR   ;  - 0h
			call       EE_read__  ; EEPROM --> W
			movwf      length_     ; 00h ---> length_

			call       EE_read__
			movwf      dist_0      ; 01h ---> dist_0

			call       EE_read__
			movwf      dist_1      ; 02h ---> dist_1

			call       EE_read__
			movwf      dist_all_0    ; 03h ---> dist_all_0

			call       EE_read__
			movwf      dist_all_1    ; 04h ---> dist_all_1

			call       EE_read__
			movwf      dist_10      ; 05h ---> dist_10

			call       EE_read__
			andlw      b'00001111'
			movwf      bright_comma ;   ,  			
			call       br_change__  ; . . .     
;-------------------------------------------------------------------------------------


            movlw      0efh
			movwf      L_sum_L
			movlw      0d8h    ;    " "
			movwf      L_sum_H	;65535-10000=55535 (D8EF)h	

			movlw      b'11110000' ;  .   -  TMR0  
			movwf      INTCON    ;   INT, 	


;------   .  -  ,  sleep   ----

			;    "0000"  32    
			movlw      0h
			movwf      OUT_0
			movwf      OUT_1
			movwf      OUT_2
			movwf      OUT_3
			call       out__
			movlw      8h
			call       pause__

			bsf        flags_,0  ;    
			call       Bat_test__ ;   . -   
			bcf        flags_,0   ;   -   
			bcf        flags_,1   ;c  .    16 .

			call       out_hide__
			call       out__       ;  


;--------------------------  --------------------------
			movlw      .9
			movwf       count_
			movlw      .26       ;VELO_SPEED
			movwf      var_temp
			call       write__
			movlw      .255
			call       pause__  ;1

			clrf       count_
			movlw      .12       ;HELLO
			movwf      var_temp
			call       write__
			movlw      .255
			call       pause__
			movlw      .255
			call       pause__  ;2





;=====================================================================================
;================================================================================            
;		       	          ( )
;================================================================================
;=====================================================================================

begin_prg   call      B_test_16__ ;   16   . 

			btfss    flags_,2  ; .  ?
			call     time_10reset__ ; 10  ?

			btfsc     PORTA,5  ;   ?
			goto      sw_control

			call      push_butt__ ;  ,  .
			xorlw     0h
			btfsc     STATUS,Z   ;W=0?
			goto      regime_l   ;   -  

		    call      br_ind__   ; ,    2   						
			goto      begin_prg

regime_l	call      regime__  ;    
			goto      begin_prg
			
sw_control	btfsc     regime_,5
			call      time_calc__ ;   

			btfsc     regime_,6
			call      Upp_out__   ;   

			btfsc     flags_,4 ;    
			goto      calc_			;   

			btfss     flags_,6 ; ? ( ) --> . .
 			goto      begin_prg     


;...................  2 . --> SLEEP  ..................

wait_off   	btfsc     regime_,4
			goto      sl_bot_1 ;  . off  

			call      out_stop__  
			movlw     .50
			movwf     Rest_Hst  ;   Rest_Hst
			movwf     Speed_Hst  ;  Speed_Hst   1- 
			call      pause__  ;  0.2 
			
			movf      pause_H,w
			andlw     b'00000011' 			
        	btfss     STATUS,Z
			goto      wait_off  ;  0  1  pause_H --> 00
			
w_off_ind 	btfss    flags_,2  ; .  ?
			call     time_10reset__ ; 10  ?

			btfsc     regime_,4
			goto      sl_bot_1 ;  . off  

			movf      pause_H,w
			andlw     b'00000011' 
			xorwf     Speed_Hst,w ;  . .,   -  
			btfsc     STATUS,Z    ; 
			goto      sl_bot_1
			call      stop_ind__  ;    -   
			movwf     Speed_Hst   ;   


sl_bot_1	btfsc     PORTA,5  
			goto      no_sw

			clrf      tmr1_count ;    
			bcf       flags_,7   ;    2 .			

			call      push_butt__ ;  ,  .
			xorlw     0h
			btfsc     STATUS,Z   ;W=0?
			goto      regime_l   ;   -  

		    call      br_ind__   ; ,    2   					
		
no_sw		call      B_test_16__ ;   16   . 
			movlw     1
			btfsc	  flags_,7 
			call      to_sleep__  ; sleep  .    2 .(W=1)

			btfsc     regime_,4
			call      out_off__

	   		movlw     .40
			call      pause__ ;  0.16 .
			btfss     flags_,4
			goto      w_off_ind   
			goto      begin_prg  ;   -    

;...................................................................................




;....................................................................................
;                     				          
;
;.....................................................................................

calc_ 		movlw     b'00001111'
			andwf      bright_comma,f ;  

	    	bcf       flags_,4  ;    
			btfss     flags_,3  ;  ?
			goto      ca_1       ;
			bcf       flags_,3   ;   

			movlw     dist_1
			movwf     FSR
			call      test10000__  

			movlw     dist_all_1
			movwf     FSR
			call      test10000__  ;   0-->9999-->0
			
ca_1			
       ;........................ ......................................

			
			call      speed_out__   ;  

			btfsc     regime_,1
			call      dist_out__    ;  . .  

			btfsc     regime_,2
			call      dist_all_out__   ;   

			btfsc     regime_,3
			goto      d_s_t_out  ;  .   4.
;..................................regime_,4 (off).....................................
			btfsc     regime_,4
			call      out_off__

			goto      begin_prg

;..........................regime_,3  (speed-->4c-->dist_-->4c-->time).....................
d_s_t_out  
			
			btfsc     pause_H,1
			bsf       dst_out,7  ;   1 pause_H =1 - .  
			btfsc     pause_H,1
			goto      dst_1
			btfss     dst_out,7
			goto      dst_1
			;  -  2-  pause_H  0  . 

			bcf       STATUS,C
			btfsc     dst_out,2
			bsf       STATUS,C
			rlf       dst_out,f ;   (-    2 )
			movlw     b'00000111'
			andwf     dst_out,f ; c  +  .

			btfsc     dst_out,0
			call      speed_out__ ;  0-  - 
			btfsc     dst_out,1
			call      dist_out__  ;  1 - . 
			btfsc     dst_out,2
			call      time_calc__ ;  2 - 

dst_1       goto      begin_prg


;======================================================================================
;======================================================================================
;======================================================================================




;==============================================================================
;  -  
;==============================================================================
text__	addwf       PCL,f
		retlw       .16			       
		retlw       .16				       
		retlw       .16				       
		retlw       .16				       
		retlw       .25				       
		retlw       .14	 			       
		retlw       .19				       
		retlw       .19				       
		retlw       .0				       
		retlw       .16			       
		retlw       .16				       
		retlw       .16				       
		retlw       .16			       
		retlw       .24 				       
		retlw       .14 				       
		retlw       .19 				       
		retlw       .0  
		retlw       .21 					       
		retlw       .5  				       
		retlw       .17 				       
		retlw       .14 
		retlw       .14 			       
		retlw       .13 
		retlw       .16	       
		retlw       .16				       
		retlw       .16				       
		retlw       .16				       
		retlw       .10			       
		retlw       .24	 			       
		retlw       .18	
		retlw       .25 			       
		retlw       .0 				       
		retlw       .20 		       
		retlw       .16			       
		retlw       .11 				       
		retlw       .10 				       
		retlw       .5  				       
		retlw       .25 
		retlw       .1  				       
		retlw       .20 	
		retlw       .16 			       
		retlw       .11       
		retlw       .10 	       
		retlw       .19	  			       
		retlw       .10 				       
		retlw       .23 	       
		retlw       .14 				       
		retlw       .24 
		retlw       .16
		retlw       .2  
		retlw       .0  
		retlw       .1  
		retlw       .3  
		retlw       .16	      
		retlw       .16				       
		retlw       .16				       
		retlw       .16	      
		retlw       .20 
		retlw       .14        
		retlw       .17 	       
		retlw       .19	  			       
		retlw       .10 				       
		retlw       .12       
		retlw       .14 				       
		retlw       .16 
		retlw       .18   			       
		retlw       .25 				       
		retlw       .14 				       
		retlw       .16 		       
		retlw       .11 
		retlw       .10 				       
		retlw       .18 				       
		retlw       .18			       
		retlw       .14		       
		retlw       .20 	       
		retlw       .23	  			       
		retlw       .16			       
		retlw       .16				       
		retlw       .16				       
		retlw       .16		      			       
;---------------------------------------------------------------------------------





;=================================================================================
;       
; 
;=================================================================================
write__		incf        PCLATH,f 	
			movf        count_,w  
			call        text__
			movwf       OUT_3     ; 1- 
			incf        count_
			movf        count_,w
			call        text__
			movwf       OUT_2    ; 2- 	 
			incf        count_
			movf        count_,w
			call        text__
			movwf       OUT_1    ; 3- 	 
			incf        count_
			movf        count_,w
			call        text__
			movwf       OUT_0    ; 4- 
			clrf        PCLATH	 
			call        out__
			movf        var_temp,w  
			subwf       count_,w
			btfsc       STATUS,C  ;  
			return	 
			decf        count_,f
			decf        count_,f  ;    
			movlw       .80
			call        pause__
 			goto        write__

;------------------------------------------------------------------------------------










;======================================================================================
;           
;======================================================================================

dist_out__
			movf        dist_0,w
			movwf       Speed_L
			movf        dist_1,w
			movwf       Speed_H  
			call        to_bcd__  ;   .-. 
			call        BCD_out__			
			bsf         bright_comma,5 ;.  2- .
			call        out__	  ;   .		
			return

;--------------------------------------------------------------------------------------



;=======================================================================================
;                 (   15  )
; 
;=======================================================================================
;..................................regime_,2  (dist_ALL) ..............................

dist_all_out__
			movf        dist_all_0,w
			movwf       Speed_L
			movf        dist_all_1,w
			movwf       Speed_H  
			call        to_bcd__  ;   .-. 
			call        BCD_out__

			movlw       b'00001111'
			andwf       bright_comma,f ;  			
			call        out__	  ;   .		

			movf        pause_H,w
			andlw       b'00001111' ;  
			xorwf       Rest_Hst,w ;   pause_H  Rest_Hst (. )
			btfss       STATUS,Z   ; ..    15 .
			goto        dis_a_end

			movlw       b'00000010'
			movwf       regime_     ; 15 . -  . --> dist  

dis_a_end	return			

;--------------------------------------------------------------------------------------





;=======================================================================================
;                 (   15  )
; 
;=======================================================================================

Upp_out__   call       Upp__   ;  w -    ""
			movwf      OUT_0
			movwf      OUT_1
			swapf      OUT_1,f ;   OUT_0, OUT_1 - 
			movlw      b'00001111'
			andwf      OUT_0,f
			andwf      OUT_1,f  ;  - 0
			movlw      .24
			movwf      OUT_3
			movlw      .21
			movwf      OUT_2
			movlw      b'00001111'
			andwf      bright_comma,f ;  
			bsf        bright_comma,5  ;   3- 			
			call       out__	  ;   .		
			movlw      .50
			call       pause__ ;  0.2 .
	        
			movf        pause_H,w
			andlw       b'00001111' ;  
			xorwf       Rest_Hst,w ;   pause_H  Rest_Hst (. )
			btfss       STATUS,Z   ; ..    15 .
			goto        upp__end

			movlw       1h
			movwf       regime_      ; 15 . -  . ()  

upp__end	return			










;======================================================================================
;                  
;
;======================================================================================

speed_out__ 
  		  ;.....................regime_,0  (speed)...................................
			movlw     b'00001111'
			andwf      bright_comma,f ;  

			btfss     flags_,5  ;    ()?
			goto      so_1      ; 
			bcf       flags_,5  ; 
			return

so_1		call      speed__   ;. 

			movlw    3       ;   .........    100,0 / ..........
			subwf    Speed_H,w
			btfss    STATUS,C
			goto     so_2
			btfss    STATUS,Z
			goto     so_3
			movlw    0e8h
			subwf    Speed_L,w
			btfss    STATUS,C
			goto     so_2  ;.........................................................

so_3		btfsc    regime_,0
			goto     so_6
			btfss    regime_,3
			return            
			btfss    dst_out,0 
			return  ;    -     "auto"( "") - 

so_6		movlw    .9
			movwf    OUT_3		
			movwf    OUT_2		
			movwf    OUT_1
			movlw    .21
			movwf    OUT_0	;    99,9 /  "99,9_"
			bsf       bright_comma,6  ;   3- .				
			goto     end_sp_out

so_2
			;------------  .  ---------------------------
			movf      Speed_H,w
			subwf     speed_max_H,w
			btfss     STATUS,C
			goto      so_4
			btfss     STATUS,Z
			goto      so_5
			movf      Speed_L,w
			subwf     speed_max_L,w
			btfsc     STATUS,C
			goto      so_5
so_4		movf      Speed_H,w
			movwf     speed_max_H
			movf      Speed_L,w
			movwf     speed_max_L
so_5
			btfsc    regime_,0
			goto     so_7
			btfss    regime_,3
			return            
			btfss    dst_out,0 
			return  ;    -     "auto"( "") - 

so_7
			call      to_bcd__ ;    .-. 
			call      BCD_out__  ;  .
			movlw     .22
			movwf     OUT_3    ;    . "u"
			bsf       bright_comma,5  ;   2- .
end_sp_out	call      out__

			return

;--------------------------------------------------------------------------------------

;======================================================================================
;         ,    10 
;======================================================================================

time_10reset__
			bcf      flags_,2
			movlw    86h         ;  pause_H, pause_Hst c  861Ah
			subwf    pause_Hst,w ;  .34330 = (10 )*3433 (3433 - - 
			btfss    STATUS,C    ;  1.04856 .   )
			return
			btfss    STATUS,Z
			goto     t10_1
			movlw    1ah-1
			subwf    pause_H,w
			btfss    STATUS,C
			return
t10_1		clrf     pause_H
			clrf     pause_Hst
			return	

;----------------------------------------------------------------------------------

;==============================================================================
;            
;==============================================================================

time_calc__
			clrf     count_
			movf     pause_H,w
			movwf    Speed_H
			movf     pause_Hst,w
			movwf    Speed_Hst ; pause_H----> Speed_H

	                 ;    ----------------------------
tc_2	;  e .3433 = 0d69h 	
			movf      Speed_Hst,w
			movwf     Rest_Hst
			movlw     69h
			subwf     Speed_H,w ; . .
			movwf     Rest_H    ; .
			btfsc     STATUS,C
			goto      tc_21
			movf      Speed_Hst,f
			btfsc     STATUS,Z
			goto      tc_3      ;  ,   .=0 - 
			decf      Speed_Hst,w ; . 
			movwf     Rest_Hst  ; .
tc_21		movlw     0dh
			subwf     Rest_Hst,w ; . .
			btfss     STATUS,C
			goto      tc_3   ;    .  - - . -  Speed_  .
			incf      count_,f
			movwf     Speed_Hst ; c.  
			movf      Rest_H,w
			movwf     Speed_H	; .  					
			goto      tc_2   ;  .-     

tc_3		movf      count_,w ;  count_  
			movwf     OUT_3    ;  

                             ;  ----------------------------------
			clrf      Rest_L
			clrf      Rest_H
tc_4		incf      Rest_L,f
			movlw     .10
			xorwf     Rest_L,w
			btfss     STATUS,Z
			goto      tc_6
			clrf      Rest_L
			incf      Rest_H,f
tc_6		movlw     .57	
			subwf     Speed_H,f
			btfsc     STATUS,C
			goto      tc_4   ;      
			decf      Speed_Hst,f  ;  ,   .
			incfsz    Speed_Hst,w  ;    / 0 - 
			goto      tc_4 

tc_5		decf      Rest_L,f
			incfsz    Rest_L,w
			goto      tc_7
			decf      Rest_H,f
			movlw     .9
			movwf     Rest_L   ;      Rest_
tc_7		movlw     .57
			addwf     Speed_H,f ;   Speed_H
  		 	; ( Rest_H . , Rest_L - 	,  Speed_H -  

			movf      Rest_H,w
			movwf     OUT_2   ; . .  .
			movf      Rest_L,w
			movwf     OUT_1  ; .  .

                               ;   .------------------------ 
			clrf      count_
tc_8		movlw     .10
			incf      count_,f
			subwf     Speed_H,f
			btfsc     STATUS,C
			goto      tc_8
			decf      count_,w  ; . . 
			movwf     OUT_0     ;  .
			bsf       bright_comma,7
			bsf       bright_comma,5 ; .  1  3 
			call      out__     ;    
			return

;---------------------------------------------------------------------------




;====================================================================================
;      -  out_bcd_X
;====================================================================================    

BCD_out__	swapf     out_bcd_1,w
			andlw     b'00001111'
			btfss     STATUS,Z
			goto      bs_3
			movlw     .16
			movwf     OUT_3     ;  3-   0

			movf      out_bcd_1,f
			btfss     STATUS,Z  ;    0? 
			goto      bs_2    ;   . 2- 
			movlw     .16    ;    
			movwf     OUT_2
			goto      bs_1   ;    

bs_3		movwf     OUT_3   ;    0,   
bs_2        movf      out_bcd_1,w
			andlw     b'00001111'
			movwf     OUT_2
bs_1        swapf     out_bcd_0,w
			andlw     b'00001111'
			movwf     OUT_1       ; 3- 
			movf      out_bcd_0,w
			andlw     b'00001111'
			movwf     OUT_0       ; 4- 
			return        
			 

;------------------------------------------------------------------------------------


;=================================================================================
;----------------------------------------------------------------------------
;         
;   - regime_(.  - 0-, 1-  (0.1 ), 
; 2-  (), 3-(1),       4 ,
; 4-   SLEEP, 5-   ,
; 6-   7- ,  
;=================================================================================


regime__ 	movf      regime_,w
			movwf     reg_temp   ;  regime_ 

r_			call      ind_re__
			call      out__

			call      wait_nobutt__

			call      wait_butt__
			xorlw     0h
			btfsc     STATUS,Z
			goto      end_re  ;   4  -   

			call      push_butt__ ;  ,  .
			xorlw     0h
			btfsc     STATUS,Z
			goto      r_3      ;   -   

			movf      regime_,w   ;     >1.5 
			btfss     regime_,7   ;  .   ".",  -
			movwf     reg_temp   ;  reg_temp		

			call      out_yes__      ;    "YES_"
			call      wait_nobutt__ ; 

			btfsc     flags_,6 ;   
			call      stat__ 
			
		    btfsc     regime_,7  
			call      set__      ; 
			movlw     .1
			btfsc     regime_,4
			call      to_sleep__ ;  SLEEP   (w=1)						
			goto      end_re
			     
r_3			rlf       regime_,w   ;   regime_
			rlf       regime_,f   ;

			goto      r_

end_re		movf      reg_temp,w
			movwf     regime_    ;  

			btfsc     regime_,6
			goto      r_5 
			btfss     regime_,2  ;   -.  
			goto      end_reg_   ;   ,  
r_5			decf      pause_H,w    ;  pause_H   
			andlw     b'00001111';     ( 			
			movwf     Rest_Hst   ;    )
			                     ;   - 15 .

			btfsc     regime_,2 
			goto      end_reg_ ;   . 
			bcf       flags_,6 ;   . 
			movlw     b'11110000'
			andwf     tmr1_count,f ;   

end_reg_	return

;----------------------------------------------------------------------------



;=================================================================================
;        .  - regime_
;=================================================================================

ind_re__	movlw   b'00001111'
			andwf   bright_comma,f

			btfsc   regime_,0
			goto    sp_    
			btfsc   regime_,1
			goto    d0_    
			btfsc   regime_,2
			goto    d1_    
			btfsc   regime_,3
			goto    sdt_  
			btfsc   regime_,4
			goto    of_  
			btfsc   regime_,5
			goto    tcal_
			btfsc   regime_,6
			goto    Upp_ 
			btfsc   regime_,7
			goto    set_ 

			return

sp_			movlw   .5
			movwf   OUT_3
			movlw   .17
			movwf   OUT_2
			movlw   .14
			movwf   OUT_1
			movlw   .14
			movwf   OUT_0
			return        ;    " S P E E"

d0_			movlw   .13
			movwf   OUT_3
			movlw   .1
			movwf   OUT_2
			movlw   .5
			movwf   OUT_1
			movlw   .18
			movwf   OUT_0
			return         ;    " d I S t "   

d1_			movlw   .13
			movwf   OUT_3
			movlw   .10
			movwf   OUT_2
			movlw   .19
			movwf   OUT_1
			movlw   .19
			movwf   OUT_0
			bsf     bright_comma,7
			return          ;      " d,A L L " 

sdt_ 		movlw   .10
			movwf   OUT_3
			movlw   .24
			movwf   OUT_2
			movlw   .18
			movwf   OUT_1
			movlw   .0
			movwf   OUT_0
			return         ;       " A U t O "

set_		movlw   .5
			movwf   OUT_3
			movlw   .14
			movwf   OUT_2
			movlw   .18
			movwf   OUT_1
			movlw   .21
			movwf   OUT_0
			return          ;       " S E T _ " 

Upp_		movlw   .24
			movwf   OUT_3
			movlw   .11
			movwf   OUT_2
			movlw   .10
			movwf   OUT_1
			movlw   .18
			movwf   OUT_0
			bsf     bright_comma,7
			return          ;       " U.b A t "

of_			movlw   .0
			movwf   OUT_3
			movlw   .15
			movwf   OUT_2
			movlw   .15
			movwf   OUT_1
			movlw   .21
			movwf   OUT_0
			return          ;       " O F F _ "

tcal_		movlw   .18
			movwf   OUT_3
			movlw   .12
			movwf   OUT_2
			movlw   .10
			movwf   OUT_1
			movlw   .19
			movwf   OUT_0
			bsf     bright_comma,7
			return        	;       " t.C A L "
;----------------------------------------------------------------------------



;====================================================================================
;     .  " S t O P "
;====================================================================================

out_stop__	movlw   b'00001111'
			andwf   bright_comma,f ; 

			movlw   .5
			movwf   OUT_3
			movlw   .18
			movwf   OUT_2
			movlw   .0
			movwf   OUT_1
			movlw   .17
			movwf   OUT_0
			call    out__
			return  

;------------------------------------------------------------------------------------


;=================================================================================
;             "OFF" (" _ _ ")
;=================================================================================


out_off__	movlw     b'00001111'
			andwf      bright_comma,f ;  
			movlw     .16
			movwf     OUT_3
			movwf     OUT_0
			movwf     OUT_2
			movwf     OUT_1  
			movlw     .21
			btfss     pause_H,0
			movwf     OUT_2
			btfsc     pause_H,0
			movwf     OUT_1   ;   " _ "  1  2-
                     ;     
			call      out__
			return
;---------------------------------------------------------------------------------




;====================================================================================
;            
;====================================================================================

out_hide__	movlw   b'00001111'
			andwf   bright_comma,f ; 

			movlw   .16
			movwf   OUT_3
			movwf   OUT_2
			movwf   OUT_1
			movwf   OUT_0
			call    out__
			return     

;------------------------------------------------------------------------------------



;====================================================================================
;     .  " Y E S _ "
;====================================================================================

out_yes__	movlw   b'00001111'
			andwf   bright_comma,f ; 

			movlw   .23
			movwf   OUT_3
			movlw   .14
			movwf   OUT_2
			movlw   .5
			movwf   OUT_1
			movlw   .21
			movwf   OUT_0
			call    out__
			return     

;--------------------------------------------------------------------------------------



;====================================================================================
;     .  " b A t.L "
;====================================================================================

out_batL__	movlw   b'00001111'
			andwf   bright_comma,f ; 

			movlw   .11
			movwf   OUT_3
			movlw   .10
			movwf   OUT_2
			movlw   .18
			movwf   OUT_1
			movlw   .19
			movwf   OUT_0
			bsf     bright_comma,5

			call    out__
			return     

;--------------------------------------------------------------------------------------






;====================================================================================
;        .10000   ,   
;    -   FSR   ,  - FSR-1
;====================================================================================
;     .10000 ( 2710H),  - >= 0,   

test10000__ movlw    27h
			subwf    INDF,w
			btfss    STATUS,C
			goto     end_10000
			btfss    STATUS,Z
			goto     t1_10000
			decf     FSR,f
			movlw    10h
			subwf    INDF,w
			btfss    STATUS,C
			goto     end_10000
			incf     FSR,f
t1_10000	clrf     INDF
			decf     FSR,f
			clrf     INDF
end_10000	return

;-------------------------------------------------------------------------------------




;----------------------------------------------------------------------------- 
;           SLEEP
;   : W -  W=0 -     
;-----------------------------------------------------------------------------
to_sleep__	clrf     count_
			andlw    0ffh
			btfss    STATUS,Z
			goto     to_sl_0
			incf     count_,f  ; W=0 ----> count_=1

		   	btfsc    flags_,0;       
			goto     to_sl_2 ;  .  -    EEPROM
 
to_sl_0		call     out_hide__   ;  
			movlw    .25
			call     pause__  ;  100    . 

;---------------   EEPROM   dist_..------
			movlw    dist_0
			movwf    FSR         ; 1- 
			movlw    5h
			movwf    var_temp   ; 5  dist_..

			bsf      STATUS,RP0  ;  1. 	       
			movlw    .1 
			movwf    EEADR  ; adr.=1
to_sl_3		call     EE_read__  ;  EEADR    
			xorwf    INDF,w
			btfsc    STATUS,Z
			goto     to_sl_4
			movf     INDF,w      ;     --> 
			bsf      STATUS,RP0  ;  1. 	       
			decf     EEADR,f	 ;     		
			call     EE_write__  ;  EEADR    
to_sl_4		incf     FSR,f       ;    dist_
			decfsz   var_temp,f
			goto     to_sl_3
;-------------------------------------------------------------------
			
to_sl_2		call     wait_nobutt__ ;  

			bcf      INTCON,GIE ;  

			movlw    0ffh 
			movwf    PORTA       ;     . . 

			movlw      0ffh
			movwf      PORTB                                              

			bsf      STATUS,RP0  ;  1.
			movlw    b'10000001' 	       
			movwf    TRISB ; 7 -      SLEEP  
			bcf      STATUS,RP0  ;  0.
			movf     PORTB,f    ;  

			btfss    count_,0  ;   W=1
			bsf      INTCON,RBIE ; .   .   RB4-RB7 

			btfsc    count_,0  ;   W=0
			bcf      INTCON,INTE ;     INT 

			bcf      INTCON,INTF ;   INT 
			bcf      INTCON,RBIF ;   RB 
						
			sleep

			bcf      INTCON,RBIE ;    .   RB4-RB7 
			movlw    b'00000001'
			bsf      STATUS,RP0  ;  1.
			movwf    TRISB ;  TRISB
			bsf      INTCON,GIE ;  
			bcf      STATUS,RP0  ;  0. 	       
	
			
			return

;-----------------------------------------------------------------------------





;=============================================================================
;           EEPROM
;     .,  . . (+1)
;=============================================================================

EE_read__	bsf        STATUS,RP0  ; BANK 1
			bsf        EECON1,RD
			movf       EEDATA,w
			incf       EEADR,f
			bcf        STATUS,RP0  ; BANK 0
			return
;-----------------------------------------------------------------------------


;=============================================================================
;           EEPROM
;     .,  . . (+1)
;=============================================================================
EE_write__  bsf        STATUS,RP0  ;  1. 
            movwf      EEDATA     ;  


			bcf        STATUS,RP0  ;  0.
			bcf        INTCON,GIE   ;  

			movlw      0ffh
			movwf      PORTB                                              

			bsf        PORTA,4    ;       

			movlw      .250
			call       delay_Wx6__
			movlw      .250
			call       delay_Wx6__     
			movlw      .250
			call       delay_Wx6__    ;  4.5  
			
			bsf        STATUS,RP0  ;  1. 	
            bsf        EECON1,WREN    ;  .                                   
            movlw      55h        ; 
            movwf      EECON2      ; 
            movlw      0AAh        ;  .
            movwf      EECON2      ; ----"----
            bsf        EECON1,WR    ; ----"----

			bsf        INTCON,GIE             ; 

            bcf        STATUS,RP0  ; 0			
eepr_1		btfss      PIR1,EEIF
			goto       eepr_1    ;   
			bcf        PIR1,EEIF  ;  .

			bsf        STATUS,RP0  ;  1. 
			bcf        EECON1,WREN ; 
			incf       EEADR,f     ;  a   
            bcf        STATUS,RP0  ; 0
			return


;-----------------------------------------------------------------------------





;==============================================================================
;                    
;==============================================================================
set__		clrf      Rest_H
			incf      Rest_H,f ; =1

se_			call      ind_set__
			call      out__

			call      wait_nobutt__

			call      wait_butt__
			xorlw     0h
			btfsc     STATUS,Z
			goto      end_se  ;   6  -   
			
			call      push_butt__
			xorlw     0h
			btfsc     STATUS,Z
			goto      se_3      ;   -   .
                           	 	  ;     >1.5 

			call      out_yes__      ;    "YES_"
			call      wait_nobutt__  ; 
			
		    btfsc     Rest_H,0  
			goto      time_clear  ;  
			btfsc     Rest_H,1
			goto      dis_clear   ;   						
		    btfsc     Rest_H,2  
			goto      br_start   ; .  
			btfsc     Rest_H,3
			call      set_length__   ;  .   () 			
			btfsc     Rest_H,4
			goto      au_
			goto      se_

;-------------------------------  ------------------------
time_clear	clrf      pause_H
			clrf      pause_Hst

			clrf      speed_max_L   
			clrf      speed_max_H  
			clrf      dist_T_L     
			clrf      dist_T_H  			

			goto      se_

;------------------------------- ----------------------------
dis_clear	bsf      STATUS,RP0  ;  1. 	       
			clrf     EEADR
			incf     EEADR,f  ; EEPROM adres = 1h

			clrw     
			call     EE_write__  ;  0  EEPROM  . 01h
			clrw
			call     EE_write__  ;    02h
			bcf      STATUS,RP0  ;  0. 
			clrf      dist_0
			clrf      dist_1  ;    
			goto      se_

;------------------------------- . ------------------------
br_start 	movf      bright_comma,w
			movwf     Rest_Hst  ; . . 
			call      br_ind__  ; -  

			bsf       STATUS,RP0  ;  1. 	       
			movlw     6h
			movwf     EEADR    ; EEPROM adres = 6h

			bcf       STATUS,RP0  ;  0. 	   
			movf      bright_comma,w
			andlw     b'00001111'			     
			call      EE_write__  ;   EEPROM  . 06h

			bcf       STATUS,RP0  ;  0. 				
			movf      Rest_Hst,w			
			movwf     bright_comma  ; . 
			call      br_change__   ;   
			goto      se_
;---------------------------------------------------------------------------
au_	    	movlw      .23
			movwf      count_
			movlw      .56      
			movwf      var_temp
			call       write__
			movlw      .255
			call       pause__
			goto       se_


    		 ; ---------------------- -------------------------				
se_3		bcf       STATUS,C
			btfsc     Rest_H,4   ;  
			bsf       STATUS,C    ;0-4  Rest_H
			rlf       Rest_H,f   ;
			movlw     b'00011111'
			andwf     Rest_H,f   ;  "000X"

			goto      se_

end_se		return


;------------------------------------------------------------------------------




;=============================================================================
;       ()   
;   Neg_Time_(Hst,H,L) - , ,   
;   Speed_Hst( 2-0) -  -.
;   Speed_H- 
;   Speed_L
;=============================================================================
set_length__
			clrf      Speed_H
			movf      length_,w
			movwf     Speed_L   ; length_ --> Speed_
			call      to_bcd__
			movf      out_bcd_1,w
			movwf     Neg_Time_Hst
			movf      out_bcd_0,w
			andlw     b'00001111'
			movwf     Neg_Time_L
			swapf     out_bcd_0,w
			andlw     b'00001111'
			movwf     Neg_Time_H     ; BCD  length_ --> Neg_Time_(Hst,H,L)
			movlw     .4
			movwf     Speed_Hst
			bcf       flash_flags,2  ;   

setl_0		movlw     .19  
			movwf     OUT_3		          
			movf      Neg_Time_Hst,w
			movwf     OUT_2
			movf      Neg_Time_H,w
			movwf     OUT_1
			movf      Neg_Time_L,w
			movwf     OUT_0
			bsf       Speed_H,7
			bsf       bright_comma,7 ; . . 3- .
			call      out__    ;    . "L.XXX"

			call      wait_nobutt__ ;     >0.1 .  

			call      wait_butt__
			xorlw     0h
			btfsc     STATUS,Z
			goto      end_setl  	;   4  -     .

			call      push_butt__ ; ,  .
			xorlw     0h
			btfsc     STATUS,Z
			goto      setl_3      ;   -   .

                           	 	  ;     >1.5 
			btfss     Speed_Hst,2  ;............................
			goto      setl_10
			movf      Neg_Time_Hst,f ;    -0
			btfss     STATUS,Z       ;   
			goto      setl_10        ;  "24"
			movlw     2h
			movwf     Neg_Time_H
			movlw     4h
			movwf     Neg_Time_L 	;.............................

setl_10		btfsc     Speed_Hst,0
			goto      setl_11
			call      out_hide__  ;    1  2 
			call      wait_nobutt__  ; 

setl_11		btfss     Speed_Hst,0
			goto      setl_8
			call      out_yes__      ;    "YES_"
			call      wait_nobutt__  ; 


	;---------------------------BCD ---> BINARY	----------------------------	
			movf      Neg_Time_H,w
			movwf     Speed_L  ; 
			bcf       STATUS,C
			rlf       Speed_L,f
			rlf       Speed_L,f
			rlf       Speed_L,f
			addwf     Speed_L,f
			addwf     Speed_L,f   ; X*10 = X*8+X+X

			incf      Neg_Time_Hst,w			
			movwf     count_    ; =+1
			movlw     .100
setl_90		decf      count_,f
			btfsc     STATUS,Z
			goto      setl_91
			addwf     Speed_L,f ; +100
			goto      setl_90
setl_91     movf      Neg_Time_L,w
			addwf     Speed_L,w ;  ---------->  
	;---------------------------------------------------------------------
			movwf     length_
			
			bsf       STATUS,RP0  ;  1. 	       
			clrf      EEADR    ; EEPROM adres = 0h
		    movf      length_,w 
			call      EE_write__  ;   EEPROM  . 0h

			bcf       STATUS,RP0  ;  0.			

			movlw     b'00001000'
			movwf     Speed_Hst
setl_8 		bcf       STATUS,C
			rrf       Speed_Hst,f ;  2-0-2.. - . 
			comf      Speed_Hst,w
			movwf     flash_flags  ;   

			goto      setl_0


;-----------   3-    024-255 ------------------

setl_3		btfss     Speed_Hst,2  ; ,   1- 
			goto      setl_5         
			incf      Neg_Time_Hst,f ;---------1- --------------------
			movlw     3h
			subwf     Neg_Time_Hst,w
			btfsc     STATUS,C
			clrf      Neg_Time_Hst  ;---- 0,1,2,0...-------------------------

setl_5		btfss     Speed_Hst,1   ; ,   2-  
			goto      setl_6
			movlw     1h
			subwf     Neg_Time_Hst,w
			btfss     STATUS,C
			goto      setl_52_9
			btfsc     STATUS,Z
			goto      setl_50_9

			incf      Neg_Time_H,f ;---------2-  (1- = 2)---------------
			movlw     6h
			subwf     Neg_Time_H,w
			btfsc     STATUS,C
			clrf      Neg_Time_H  ;----0,1,2,3,4,5,0...-----------------------			
 			goto      setl_6

setl_52_9	incf      Neg_Time_H,f ;---------2-  (1- = 0)---------------
			movlw     0ah
			subwf     Neg_Time_H,w
			movlw     2h
			btfsc     STATUS,C
			movwf     Neg_Time_H  ;----2,3...9,2....-------------------------
			goto      setl_6

setl_50_9	incf      Neg_Time_H,f ;---------2-  (1- = 1)--------------
			movlw     0ah
			subwf     Neg_Time_H,w
			btfsc     STATUS,C
			clrf      Neg_Time_H  ;----0 - 9,0...----------------------------
				
setl_6		btfss     Speed_Hst,0   ; ,   3-  
			goto      setl_7
			movf      Neg_Time_Hst,f
			btfss	  STATUS,Z
			goto      setl_61
			movlw     2h
			xorwf     Neg_Time_H,w
			btfss     STATUS,Z
			goto      setl_61
			incf      Neg_Time_L,f ;---------3- (1,2 ---> 02)----------
			movlw     0ah
			subwf     Neg_Time_L,w
			movlw     4h
			btfsc     STATUS,C
			movwf     Neg_Time_L  ;----4...9, 4...----------------------------
			goto      setl_7	
setl_61		movlw     2h
			xorwf     Neg_Time_Hst,w
			btfss     STATUS,Z
			goto      setl_60_9
			movlw     5h
			xorwf     Neg_Time_H,w
			btfss     STATUS,Z						
			goto      setl_60_9
			incf      Neg_Time_L,f ;---------3- (1,2 ---> 25)-----------
			movlw     6h
			subwf     Neg_Time_L,w
			btfsc     STATUS,C
			clrf      Neg_Time_L  ;----0,1,2,3,4,5,0...-----------------------
			goto      setl_7
setl_60_9	incf      Neg_Time_L,f ;---------3- (1,2 ---> 03...24)---
			movlw     0ah
			subwf     Neg_Time_L,w
			btfsc     STATUS,C
			clrf      Neg_Time_L  ;----0...9, 0...----------------------------	
;-----------------------------------------------------------------------------

setl_7		goto         setl_0



end_setl	clrf         flash_flags
			comf         flash_flags,f  ; '11111111' - . 
			return







;=================================================================================
;        .  - Rest_H
;=================================================================================

ind_set__	movlw   b'00001111'
			andwf   bright_comma,f

			btfsc   Rest_H,0
			goto    tcl_    
			btfsc   Rest_H,1
			goto    dcl_    
			btfsc   Rest_H,2
			goto    bst_    
			btfsc   Rest_H,3
			goto    setL_  
			btfsc   Rest_H,4
			goto    aut_    

			return

tcl_		movlw   .18
			movwf   OUT_3
			movlw   .21
			movwf   OUT_2
			movlw   .12
			movwf   OUT_1
			movlw   .19
			movwf   OUT_0
			return        ;    " t _ C L"

dcl_		movlw   .13
			movwf   OUT_3
			movlw   .21
			movwf   OUT_2
			movlw   .12
			movwf   OUT_1
			movlw   .19
			movwf   OUT_0
			return         ;    " d _ C L "   

bst_		movlw   .11
			movwf   OUT_3
			movlw   .20
			movwf   OUT_2
			movlw   .5
			movwf   OUT_1
			movlw   .18
			movwf   OUT_0
			bsf     bright_comma,6
			return          ;      " B r.S t " 

setL_ 		movlw   .5
			movwf   OUT_3
			movlw   .14
			movwf   OUT_2
			movlw   .18
			movwf   OUT_1
			movlw   .19
			movwf   OUT_0
			bsf     bright_comma,5
			return         ;       " S E t.L "

aut_ 		movlw   .10
			movwf   OUT_3
			movlw   .24
			movwf   OUT_2
			movlw   .18
			movwf   OUT_1
			movlw   .25
			movwf   OUT_0
			return         ;       " A u t H "

;----------------------------------------------------------------------------

         


 
;===============================================================================
;      
;    bright_comma, Speed_H
;===============================================================================

br_ind__ 	movlw     b'00001111'
			andwf     bright_comma,f ; 
   			movf      bright_comma,w
			movwf     Speed_H     ;   
br_1		movlw     .11
			movwf     OUT_3
			movlw     .20
			movwf     OUT_2
			movlw     .16
			movwf     OUT_1
			movf      bright_comma,w
			andlw     b'00001111'
			movwf     OUT_0 
			bcf       flash_flags,0  
			bsf       bright_comma,6 ;   3- .
			call      out__  ; 12  -  "Br X c  . "

			call      wait_nobutt__ ;     >0.1 .  

			call      wait_butt__
			xorlw     0h
			btfsc     STATUS,Z
			goto      br_4		;   4  -     .

			call      push_butt__ ; ,  .
			xorlw     0h
			btfsc     STATUS,Z
			goto      br_3      ;   -   .

			call      out_yes__		
			goto      br_5  ;     >2 ,   .
							;   



br_3		incf      bright_comma,f  ;------------------------------
			movf      bright_comma,w  ;   br_idend
			andlw     b'00001111'
			sublw     5h
			movlw     b'11110000'
			btfss     STATUS,C        ;  x-->x+1 ...--> 0,1,2,3,4,5,0... 
			andwf     bright_comma,f  ;   -------------------
			call      br_change__ ;  
			goto      br_1

br_4   		movf      Speed_H,w
			movwf     bright_comma ; .  .
			call      br_change__

br_5		call      wait_nobutt__ ;     >0.16 .  
			bsf       flash_flags,0  ; . 
	
		    return

;------------------------------------------------------------------------------




;==========================================================================
;      
;   bright_comma (0 - 5)
;==========================================================================
br_change__	swapf     bright_comma,w
			iorlw     b'00001111'  ;    'XXXX1111'
			movwf     Rest_L
			sublw     b'00101111'
			movf      Rest_L,w
			btfsc     STATUS,C     ; .= 0,1,2 -->  0F,1F,2F
			goto      br_ch_1
			movlw     0ffh
			btfss     Rest_L,6
			movlw     b'01001111'
			btfss     Rest_L,4
			movlw     b'10001111'	; . 3,4,5 -->  4F,8F,FF					
br_ch_1		bsf       STATUS,RP0 ; bank 1
			movwf     PR2      ;   . 
			bcf       STATUS,RP0  ; bank0 
			return
;--------------------------------------------------------------------------





;==============================================================================
;    0.04 - 1 
;   pause_,  -  "W"   (P = w*4 mc)
;==============================================================================

pause__                ;  w  10  256,  0.04 - 1 . 
			addwf        pause_,w
			movwf        var_pause ;var_pause=pause+w
			  
p_1			movf         pause_,w
			xorwf        var_pause,w ;  pause_ (   TMR0)
			btfss        STATUS,Z ;   pause_= var_pause
			goto         p_1
			return                 

;------------------------------------------------------------------------------


;==============================================================================
;                    
;   - OUT_0, OUT_1, OUT_2, OUT_3     - LED_OUT_0, LED_OUT_1,
;                                               LED_OUT_2, LED_OUT_3
;==============================================================================

out__		bcf       INTCON,GIE  ;  .		
			movf      OUT_0,w
			call      Table_s  ; .   7-. .
			movwf     LED_OUT_0
 			btfsc     bright_comma,4
			bsf       LED_OUT_0,0    ;.   . 

			movf      OUT_1,w	
			call      Table_s  ; .   7-. .
			movwf     LED_OUT_1
 			btfsc     bright_comma,5
			bsf       LED_OUT_1,0 ;.   . 

			movf      OUT_2,w
			call      Table_s  ; .   7-. .
			movwf     LED_OUT_2
 			btfsc     bright_comma,6
			bsf       LED_OUT_2,0 ;.   . 

			movf      OUT_3,w
			call      Table_s ; .   7-. . 
			movwf     LED_OUT_3 
 			btfsc     bright_comma,7
			bsf       LED_OUT_3,0 ;.   . 

			bsf       INTCON,GIE ;  
			return
;------------------------------------------------------------------------------


;==============================================================================
;                >0.12 .  
;   
;==============================================================================

wait_nobutt__   btfss     PORTA,5
				goto      wait_nobutt__ ;   

				movlw     .30
				call      pause__  ; 0.12 sec
				btfss     PORTA,5  ;     >0.12 .  
				goto      wait_nobutt__
				return

;-------------------------------------------------------------------------------



;===================================================================================
;              
;     :  W - 1 -  , 0 -     5 .
;===================================================================================
wait_butt__	movlw     .50
			movwf     count_
wai_b		movlw     .25
			call      pause__
			btfss     PORTA,5   
			retlw     1h       ;  w=1,   
			decfsz    count_,f 
			goto      wai_b     ;  50*100=5   	  
			retlw     0h 		;   5  -     w=0.
;-----------------------------------------------------------------------------------




;===================================================================================
;               
;     :  W - 1 -   . >2 c, 0 -  -   . <2 c
;===================================================================================

push_butt__	movlw     .15
			movwf     count_
pub_1 		movlw     .30
			call      pause__
			btfsc     PORTA,5    ;   ,   
			retlw     0h        ;   - W=0
			decfsz    count_,f ;  15*120=1.8   
			goto      pub_1
			retlw     1h       ; >2c - W=1

;----------------------------------------------------------------------------------





;-------------------------------------------------------------------------------



;=====================================================================================
;                     
;          -----------------------------------------
; : length_, Time_L, Time_H, 
;       V = ( length_ * 2813 ) / Time_ , : 
;  V       -   - Speed_L, Speed_H ( -  0.1 /)
;  length_ -        (   -  -
;             )  
;  Time_   -   Time_L, Time_H,     
;=====================================================================================

speed__

;--------------------------------------------------------------------------
;     e       
;      2813()
;       X*2813=X*(176*16-3)= (X*176)*16-X*3
;--------------------------------------------------------------------------

           	; ---> length_*176-->Speed_H,Speed_L			
	   		clrf      Speed_L
			clrf      Speed_H
			clrf      Speed_Hst
			movlw     .176
			movwf     var_temp
			movlw     8
			movwf     count_
			movf      length_,w
			bcf       STATUS,C
loop_x      rrf       var_temp,f
			btfsc     STATUS,C
			addwf     Speed_H,f
			rrf       Speed_H,f
			rrf       Speed_L,f
			decfsz    count_,f
			goto      loop_x  ;  


			; -----------    16 -------------------		
			movlw     4
			movwf     count_
			bcf       STATUS,C
loop_r      rlf      Speed_L,f
			rlf       Speed_H,f  ;  Speed_X  16 (  4 )
			rlf       Speed_Hst,f
			decfsz    count_,f
			goto      loop_r
			
			; ------------  3*length_ -------------------------
			clrf      count_
			movf      length_,w
			addwf     length_,w
			btfsc     STATUS,C
			incf      count_,f
			addwf     length_,w
			btfsc     STATUS,C
			incf      count_,f  ; length_ x 3

			subwf    Speed_L,f
			btfss     STATUS,C
			incf      count_,f
			movf      count_,w
			subwf     Speed_H,f
			btfss     STATUS,C
			decf      Speed_Hst,f      ; A - length_ * 3 ---> A

;===================================================================================		
;-------------------------------------------------------------------------------			
;           Speed_(3-  )  Time_ (3- . , )	
;       - 3-   Speed_ (   -    0)
;-------------------------------------------------------------------------------- 
Speed_div__
           movlw       .24
           movwf       count_
           clrf        Rest_L
           clrf        Rest_H
           clrf        Rest_Hst 
		   clrf        Time_Hst	     ; Time_Hst -  = 0

           movf        Time_L,w
           movwf       Neg_Time_L
           movf        Time_H,w
           movwf       Neg_Time_H 
           movf        Time_Hst,w
           movwf       Neg_Time_Hst  
  
           comf        Neg_Time_L,f  ;  Neg_Time_L, Neg_Time_H, Neg_Time_Hst  c. .
           comf        Neg_Time_H,f  ;   
           comf        Neg_Time_Hst,f  ;     
           incfsz      Neg_Time_L,f  ;  1 
           goto        st_calc_
           incfsz      Neg_Time_H,f
           goto        st_calc_
           incf        Neg_Time_Hst,f
   
		   bcf         STATUS,C	
st_calc_
           rlf         Speed_L,f
           rlf         Speed_H,f
           rlf         Speed_Hst,f              
           rlf         Rest_L,f
           rlf         Rest_H,f
           rlf         Rest_Hst,f  ;    "Rest_"
           
           ;    "   "Rest_" ,  .  ,
           ;         ,      
           ;     .
  
           movf        Time_Hst,w
           subwf       Rest_Hst,w
           btfss       STATUS,C  ;  C=0,     "Rest_" 
           goto        nosub_    ;  
           btfss       STATUS,Z  ;   .   
           goto        sub_1     ; 

           movf        Time_H,w
           subwf       Rest_H,w
           btfss       STATUS,C  
           goto        nosub_
           btfss       STATUS,Z  ; c   -   
           goto        sub_1     ; 
           movf        Time_L,w
           subwf       Rest_L,w
           btfss       STATUS,C
           goto        nosub_   ;     .        
           
sub_1      movf        Neg_Time_L,w    ;   
           addwf       Rest_L,f    ;    
           btfss       STATUS,C ;   "Rest_"     
           goto        notc_1   ;  ("Neg_Time_")
           incfsz      Rest_H,f           
           goto        notc_1   
           incf        Rest_Hst,f

notc_1     movf        Neg_Time_H,w
           addwf       Rest_H,f
           btfss       STATUS,C
           goto        notc_2
           incf        Rest_Hst,f

notc_2     movf        Neg_Time_Hst,w
           addwf       Rest_Hst,f

           bsf         STATUS,C   ;    - 1

nosub_     decfsz      count_,f   ;    goto,  -0 
           goto        st_calc_
         
        
           rlf         Speed_L,f     ;   "Speed_"  
           rlf         Speed_H,f     ;  
           rlf         Speed_Hst,f
			;----------------------------------------------------------


			;----------------------------------------------------------
			;   -      (Time_),
			;                           .
			;----------------------------------------------------------- 
			movf        Rest_L,w
			addwf       Rest_L,f
			movf        Rest_H,w
			btfss       STATUS,C
			goto        no_incRes
			incf        Rest_H,f
			btfsc       STATUS,Z
			goto        inc_Sp   ;   FFFF -  
no_incRes	addwf       Rest_H,w			
			btfsc       STATUS,C
			goto        inc_Sp	 ;   FFFF - 		
			subwf       Time_H,w
			btfss       STATUS,C ;       
			goto        inc_Sp   

			btfss       STATUS,Z  ;   ,  
			goto        end_inc_S
			movf        Rest_L,w
			subwf       Time_L,w
			btfss       STATUS,C
			goto        inc_Sp
			goto        end_inc_S

inc_Sp		incfsz      Speed_L,f
			goto        end_inc_S
			incf        Speed_H,f      ;    Speed_   

end_inc_S   return					;  Speed_L  Speed_H   	


;---------------------   ----------------------------


;======================================================================================
;        - (BCD) 
;    - Speed_H, Sped_L;   - out_bcd_2, out_bcd_1, out_bcd_0 (  -
;    - ,   .  )
;====================================================================================== 


to_bcd__  
			bcf        STATUS,C
			movlw      .16
			movwf      count_
			clrf       out_bcd_2
			clrf       out_bcd_1
			clrf       out_bcd_0
loop16		rlf        Speed_L,f
			rlf        Speed_H,f
			rlf        out_bcd_0,f
			rlf        out_bcd_1,f
			rlf        out_bcd_2,f
	
			decfsz	   count_,f
			goto       adjDEC
			return

adjDEC      movlw      out_bcd_0
			movwf      FSR
			call       adjBCD
            movlw      out_bcd_1
			movwf      FSR
			call       adjBCD
            movlw      out_bcd_2
			movwf      FSR
			call       adjBCD

			goto       loop16

adjBCD      movlw      3
			addwf      INDF,w
			movwf      var_temp
			btfsc      var_temp,3 ; >7
			movwf      INDF
			movlw      30h
			addwf      INDF,w
			movwf      var_temp
			btfsc      var_temp,7 ; >127 (.  >3)
			movwf      INDF  ; 
			retlw      0		


;-----------------------   2-->10 -----------------------------------------------



;======================================================================
;   W*6 . (   )
;======================================================================
delay_Wx6__	addlw       -1
			nop
			nop	  
			btfss       STATUS,Z
			goto        delay_Wx6__
			return
;-----------------------------------------------------------------------



		
;====================================================================================
;           
; 
;====================================================================================
Bat_test__	bcf       INTCON,GIE
			bcf       PORTA,1      ; a1=0
			bsf       PORTA,4

			movlw     0ffh
			movwf     PORTB    ;                      
			
			movlw     b'00000010'  ;   . V. 
			movwf     CMCON
			bsf       STATUS,RP0   ;  1
			movlw     b'11100001'
			movwf     TRISA        ; RA0 - . 

			movlw     b'10100110'   ; U.=6/24*Upp=0.75V===>Vpp=3.25V
			movwf     VRCON        ; . .    ., . . 
			bcf       STATUS,RP0   ; 0
			movlw     .25
			call      delay_Wx6__  ; 0.15 msec

			clrf      count_
			incf      count_,f
			btfsc     CMCON,C1OUT  ;  Ubat<3.25V,  -->count_=1 
			goto      b_test_0  
          
			incf      count_,f       ; =2
			bsf       STATUS,RP0   ;  1  
			incf      VRCON,f      ;  Vp: U.=7/24*Upp=0.875V===>Vpp=3.375V
			movlw     2
			call      delay_Wx6__   ;  15 .
			bcf       STATUS,RP0   ; 0
			btfsc     CMCON,C1OUT 
			goto      b_test_0           ;  Ubat<3.375V,  -->count_=2  
  			movlw     4h
			movwf     count_	        ;  Ubat>3.375V,   -->count_=4

b_test_0	movlw     b'00000111' 
			movwf     CMCON     ; comp-> off 
			movlw     b'11100000'
			bsf       STATUS,RP0   ;  1 
			clrf      VRCON        ;  . .  
			movwf     TRISA        ; PORTA   .
			bsf       INTCON,GIE  ; .
			bcf       STATUS,RP0   ;  0

			btfss     count_,0    
			bcf       flags_,1    ; 3.25<U - c  . . 
			
			btfsc     count_,2
			return            ; >3,375 -   

			btfsc     count_,1 
			goto      b_test_1    ; 3.25<U<3.375

			btfsc     flags_,0
			goto      b_test_2   ;   U<3.25V - .  .

			btfsc     flags_,1
			goto      b_test_2  ;  . ( 1), ..  
						;  -      EEPROM
                        ;   
			bsf       flags_,1  ;  -  .  - 
			goto      b_test_1

b_test_2	movlw     b'11110000'
			movwf     flash_flags 
			call      out_batL__   ;---------    "b A t.L"
			movlw     .250
			call      pause__					
			movlw     .250
			call      pause__					
			movlw     .250
			call      pause__					
			movlw     .250
			call      pause__	   ;   4 .

			movlw   b'00001111'
			andwf   bright_comma,f ; 
			movlw     0ffh
			movwf     flash_flags  ; 			

					;   "replace the battery" -  
			movlw      .53
			movwf      count_
			movlw      .79      ;rEPLACE tHE bAttErY
			movwf      var_temp
			call       write__				

 			clrw
			call      to_sleep__  ; . . (W=0 -   )
			return

b_test_1	call      out_batL__ ;  "Bat.L"   1
			movlw     .255
			call      pause__					
			return


;-----------------------------------------------------------------------------			


;=======================================================================================
;     1   16 .
;========================================================================================	
			
B_test_16__			  ;------------   16 .  . ----------------
			btfss     pause_H,4
			goto      b_t_1
			btfsc     flags_,0
			return    ;  ,    16   
			call      Bat_test__
			bsf       flags_,0  ;   -  
			return

b_t_1		btfsc     flags_,0
			bcf       flags_,0  ;   ,  
			return
			;....................................................................

;------------------------------------------------------------------------------------------


;==================================================================================
;        . ,    
;        
;==================================================================================


stat__ 
			btfss     regime_,0  ; .   . ""
			return
			movlw     b'10000001' ;    . 
			movwf     dst_out
stat_0			
			btfsc     pause_H,1
			bsf       dst_out,7  ;   1 pause_H =1 - .  
			btfsc     pause_H,1
			goto      stat_1
			btfss     dst_out,7
			goto      stat_1
			;  -  1-  pause_H  0  . 

			btfsc     dst_out,0
			call      speed_max__ ; 0-  - max-
			btfsc     dst_out,1
			call      speed_avr__ ; 1 -      .  
			btfsc     dst_out,2
			call      dist_time0__ ; 2-  -     .  			
			btfsc     dst_out,3
			call      time_calc__ ; 3 - 

			bcf       STATUS,C
			btfsc     dst_out,3
			bsf       STATUS,C
			rlf       dst_out,f ;   (-    2 )
			movlw     b'00001111'
			andwf     dst_out,f ; c  +  .

stat_1  

			btfsc       flags_,4 ;   	
    		return

			btfsc	  flags_,7 
			return  ; :    2 .

			btfsc       PORTA,5
			goto        stat_0
			clrf      tmr1_count ;    
			bcf       flags_,7   ;    2 .			
			call        wait_nobutt__ ;      
			return


;====================================================================================
;               
;  : speed_max_H, speed_max_L
;====================================================================================			

speed_max__	
			movlw   b'00001111'
			andwf   bright_comma,f

			movf      speed_max_H,w
			movwf     Speed_H
			movf      speed_max_L,w
			movwf     Speed_L

			call      to_bcd__ ;    .-. 
			call      BCD_out__  ;  .
			movlw     .27
			movwf     OUT_3    ;    . . 
			bsf       bright_comma,5  ;   2- .
			call      out__

			return

;------------------------------------------------------------------------------------




;====================================================================================
;                  
; Paremeters: dist_T_H, dist_T_L, pause_H, pause_Hst
; V(cp)=3600*dist_T/(pause_H*1.04856) ~=((512-64-16-2-1)*2*dist_T/pause_H)*4 
; 
;====================================================================================			
speed_avr__
					;  (512-64-16-2-1)X = 512X-64X-16X-2X-X -------------------------
			movf       dist_T_L,w ;
			movwf      Speed_H    ;
			movf       dist_T_H,w ; dist_T*256*2 --> Speed
			movwf      Speed_Hst  ;
			clrf       Speed_L    ;
			bcf        STATUS,C	  ;	
			rlf        Speed_L,f  ;   
			rlf        Speed_H,f  ;
			rlf        Speed_Hst,f; *512

			movf      dist_T_H,w ;
			movwf     Rest_H     ;
			movf      dist_T_L,w ;
			movwf     Rest_L     ; dist_T --> Rest
  		    clrf      Rest_Hst   ;
			call      sub_SR__   ;------ -1 ---------------------
		
			bcf        STATUS,C	  ;	
  		    rlf       Rest_L,f   ;
			rlf       Rest_H,f   ;
			rlf       Rest_Hst,f ; 
			call      sub_SR__   ;------ -2 ---------------------

			bcf        STATUS,C	  ;	
  		    rlf       Rest_L,f   ;
			rlf       Rest_H,f   ;
			rlf       Rest_Hst,f ; 
  		    rlf       Rest_L,f   ;
			rlf       Rest_H,f   ;
			rlf       Rest_Hst,f ; 
  		    rlf       Rest_L,f   ;
			rlf       Rest_H,f   ;
			rlf       Rest_Hst,f ; 
			call      sub_SR__   ;------ -16 ---------------------

			bcf        STATUS,C	  ;	
  		    rlf       Rest_L,f   ;
			rlf       Rest_H,f   ;
			rlf       Rest_Hst,f ; 
  		    rlf       Rest_L,f   ;
			rlf       Rest_H,f   ;
			rlf       Rest_Hst,f ; 
			call      sub_SR__   ;------ -64 ---------------------

			bcf        STATUS,C	  ;		
			rlf        Speed_L,f  ; *2
			rlf        Speed_H,f  ;
			rlf        Speed_Hst,f; (512-64-16-2-1)*2*dist_T

			;  ,  4,     3 
			
			bcf       INTCON,GIE ; . .	
			movf      pause_H,w   ;
			movwf     Time_L      ;
			movf      pause_Hst,w ; 
			movwf     Time_H      ;
			call      Speed_div__ ; / --->Speed <--- (512-64-16-2-1)*2*dist_T/pause 
			bsf       INTCON,GIE ;  .	

			bcf        STATUS,C	  ;		
			rlf        Speed_L,f  ;
			rlf        Speed_H,f  ;
			rlf        Speed_Hst,f;
			rlf        Speed_L,f  ;
			rlf        Speed_H,f  ;
			rlf        Speed_Hst,f;  --->Speed <--- 429*2*4*dist_T/pause 

			movlw   b'00001111'
			andwf   bright_comma,f ;  

			call      to_bcd__ ;  Speed  .-. 
			call      BCD_out__  ;  .
			movlw     .26
			movwf     OUT_3    ;    . "-"
			bsf       bright_comma,5  ;   2- .
			call      out__

			return


;--------------------------------------------------------------------------------------




;=================================================================================
;   3-  
;=================================================================================  
sub_SR__	movf      Rest_Hst,w   ;-------------------------
			subwf     Speed_Hst,f
			movf      Rest_H,w
			subwf     Speed_H,f
			btfss     STATUS,C
			decf      Speed_Hst,f
			movf      Rest_L,w     ; Speed <--- Speed-Rest
			subwf     Speed_L,f
			btfss     STATUS,C
			decf      Speed_H,f
			incf      Speed_H,w
			btfsc     STATUS,Z
			decf      Speed_Hst,f   ;-------------------------
			return
;----------------------------------------------------------------------------------


		

;======================================================================================
;              
;   : dist_T_H, dist_T_L
;======================================================================================

dist_time0__
			movf        dist_T_L,w
			movwf       Speed_L
			movf        dist_T_H,w
			movwf       Speed_H  
			call        to_bcd__  ;   .-. 
			call        BCD_out__			
			bsf         bright_comma,5 ;.  2- .
			call        out__	  ;   .		
			return

;--------------------------------------------------------------------------------------
	

			
		


			end
